package hu.bme.mit.mdsd.service.generator

import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.IFileSystemAccess
import org.eclipse.xtext.generator.IGenerator
import service.Service
import service.NamedElement

class ServiceModelGenerator implements IGenerator {
	
	override void doGenerate(Resource input, IFileSystemAccess fsa) {
		for (eObject : input.contents) {
			eObject.compile(fsa)
		}
		fsa.generateFile("system.properties", "SRCGEN2", input.generate)
	}
	
	def generate(Resource input) '''
		FOR ne : input.allContents.toIterable.filter(typeof (NamedElement))
		ne.eClass.name = ne.name
		ENDFOR
	'''
	
	def dispatch void compile(EObject m, IFileSystemAccess fsa) { }
	
	def dispatch void compile(service.System system, IFileSystemAccess fsa) {
		for (service : system.services) {
			service.compile(fsa)
		}
	}
	
	def compile(Service service, IFileSystemAccess fsa) {
		fsa.generateFile(service.name + ".txt", '''Hello service.name!''')
	}
	
}